package it.inaf.oats.ia2.tapschemamanager.businesslayer;

import java.sql.SQLException;
import java.util.List;

/**
 *
 * @author Sonia Zorba <zorba at oats.inaf.it>
 * @param <T>
 */
public interface EntityWrapperContainer<T extends EntityWrapper> {

    public T getEntity(String name);

    public T getSelectedEntity();

    public void selectEntity(String entityName);

    public List<String> getEntitiesNames();
    
    public List<String> getAddables();

    public <T> List<T> getAllEntityWrappers();

    public void addEntityWrapper(String name) throws SQLException;

    public void removeEntityWrapper(String name);

    public boolean hasChildren();
}
