package it.inaf.oats.ia2.tapschemamanager.datalayer;

import java.io.Serializable;
import java.math.BigInteger;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.Id;
import javax.persistence.IdClass;
import javax.persistence.ManyToOne;
import javax.persistence.PrimaryKeyJoinColumn;
import javax.persistence.Table;

class ColumnId implements Serializable {

    private static final long serialVersionUID = 6943729649657196881L;

    String fullTableName;
    String name;
}

/**
 *
 * @author Sonia Zorba <zorba at oats.inaf.it>
 */
@Entity
@IdClass(ColumnId.class)
@Table(name = "columns")
public class ColumnEntity implements Serializable, TapSchemaEntity {

    private static final long serialVersionUID = 3630294743516824359L;

    @Id
    @Column(name = "table_name", length = 128)
    private String fullTableName;

    @Id
    @Column(name = "column_name", length = 64)
    private String name;

    @ManyToOne(fetch = FetchType.EAGER)
    @PrimaryKeyJoinColumn(name = "table_name", referencedColumnName = "table_name")
    private TableEntity table;

    @Column(name = "utype", length = 512)
    private String utype;

    @Column(name = "ucd", length = 64)
    private String ucd;

    @Column(name = "unit", length = 64)
    private String unit;

    @Column(name = "description", length = 512)
    private String description;

    @Column(name = "datatype", length = 64)
    private String datatype;

    @Column(name = "size")
    private int size;

    @Column(name = "principal")
    private int principal;

    @Column(name = "indexed")
    private int indexed;

    @Column(name = "std")
    private int std;

    @Column(name = "columnID")
    private BigInteger columnID;
    
    @Column(name = "id")
    private int id;

    protected ColumnEntity() {
    }

    protected ColumnEntity(String columnName) {
        this();
        this.name = columnName;
    }

    public String getFullTableName() {
        return fullTableName;
    }

    protected void setFullTableName(String fullTableName) {
        this.fullTableName = fullTableName;
    }

    @Override
    public String getName() {
        return name;
    }

    protected void setName(String columnName) {
        this.name = columnName;
    }

    public String getUtype() {
        return utype;
    }

    public void setUtype(String utype) {
        this.utype = utype;
    }

    public String getUcd() {
        return ucd;
    }

    public void setUcd(String ucd) {
        this.ucd = ucd;
    }

    public String getUnit() {
        return unit;
    }

    public void setUnit(String unit) {
        this.unit = unit;
    }

    public String getDescription() {
        return description;
    }

    public void setDescription(String description) {
        this.description = description;
    }

    public String getDatatype() {
        return datatype;
    }

    public void setDatatype(String datatype) {
        this.datatype = datatype;
    }

    public int getSize() {
        return size;
    }

    public void setSize(int size) {
        this.size = size;
    }

    public int getPrincipal() {
        return principal;
    }

    public void setPrincipal(int principal) {
        this.principal = principal;
    }

    public int getIndexed() {
        return indexed;
    }

    public void setIndexed(int indexed) {
        this.indexed = indexed;
    }

    public int getStd() {
        return std;
    }

    public void setStd(int std) {
        this.std = std;
    }

    protected BigInteger getColumnID() {
        return columnID;
    }

    protected void setColumnID(BigInteger columnID) {
        this.columnID = columnID;
    }

    public TableEntity getTable() {
        return table;
    }

    protected void setTable(TableEntity tableEntity) {
        this.table = tableEntity;
    }

    public int getId() {
        return id;
    }

    public void setId(int id) {
        this.id = id;
    }
}
