package it.inaf.oats.ia2.tapschemamanager.datalayer;

import java.io.Serializable;
import java.math.BigInteger;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.Id;
import javax.persistence.IdClass;
import javax.persistence.ManyToOne;
import javax.persistence.PrimaryKeyJoinColumn;
import javax.persistence.Table;

class KeyColumn implements Serializable {
    
    private static final long serialVersionUID = 1244476100879775193L;

    String keyId;
    String fromColumn;
    String targetColumn;
}

/**
 *
 * @author Sonia Zorba <zorba at oats.inaf.it>
 */
@Entity
@IdClass(KeyColumn.class)
@Table(name = "key_columns")
public class KeyColumnEntity implements Serializable {
    
    private static final long serialVersionUID = -1841850907719547336L;

    @Id
    @Column(name = "key_id", length = 64)
    private String keyId;

    @Id
    @Column(name = "from_column", length = 64)
    private String fromColumn;

    @Id
    @Column(name = "target_column", length = 64)
    private String targetColumn;

    @Column(name = "key_columnID")
    private BigInteger keyColumnID;

    @ManyToOne(fetch = FetchType.EAGER)
    @PrimaryKeyJoinColumn(name = "key_id", referencedColumnName = "key_id")
    private KeyEntity key;

    public String getKeyId() {
        return keyId;
    }

    public void setKeyId(String keyId) {
        this.keyId = keyId;
    }

    public String getFromColumn() {
        return fromColumn;
    }

    public void setFromColumn(String fromColumn) {
        this.fromColumn = fromColumn;
    }

    public String getTargetColumn() {
        return targetColumn;
    }

    public void setTargetColumn(String targetColumn) {
        this.targetColumn = targetColumn;
    }

    public BigInteger getKeyColumnID() {
        return keyColumnID;
    }

    public void setKeyColumnID(BigInteger keyColumnID) {
        this.keyColumnID = keyColumnID;
    }

    public KeyEntity getKey() {
        return key;
    }
}
